/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mapping are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2002 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Release: 1.0
 *
 * Contact: pascal.dechamboux@rd.francetelecom.com
 *
 * Authors: R. Basset, S. Chassande-Barrioz, P. Dechamboux, N. De Palma,
 *          A. Lefebvre, X. Spengler.
 *
 */
package org.objectweb.jorm.runtime.mapper.rdb.adapter.lib;

import org.objectweb.jorm.type.api.PType;
import org.objectweb.jorm.api.PExceptionProtocol;

/**
 * This class is a sql adapter for the Firebird relational database.
 * 
 * FireBird 1.0.2 with JayBird JCA/JDBC Driver for Firebird 1.0RC2
 *FAIL: VARCHAR: create table: GDS Exception. Dynamic SQL Error
 *FAIL: VARCHAR: create table: GDS Exception. Dynamic SQL Error
 *FAIL: BIT: create table: GDS Exception. Dynamic SQL Error
 *FAIL: TINYINT: create table: GDS Exception. Dynamic SQL Error
 *FAIL: BIGINT: create table: GDS Exception. Dynamic SQL Error
 *FAIL: DOUBLE: create table: GDS Exception. Dynamic SQL Error
 *FAIL: DATE: create table: GDS Exception. Dynamic SQL Error
 *
 * @author S.Chassande-Barrioz
 */
public class FirebirdAdapter extends BasicRdbAdapter {

	public FirebirdAdapter() {
		super();
	}

	public String getSqlType(PType pt, boolean usedInPK) throws PExceptionProtocol {
		if (pt == null) {
			throw new PExceptionProtocol("No Sql Type name associated to a null PType");
		}
		switch (pt.getTypeCode()) {
		case PType.TYPECODE_BOOLEAN:
		case PType.TYPECODE_OBJBOOLEAN:
			return "?????";
		case PType.TYPECODE_BYTE:
		case PType.TYPECODE_OBJBYTE:
			return "?????";
		case PType.TYPECODE_LONG:
		case PType.TYPECODE_OBJLONG:
			return "?????";
		case PType.TYPECODE_DOUBLE:
		case PType.TYPECODE_OBJDOUBLE:
			return "?????";
		case PType.TYPECODE_DATE:
			return "?????";
		case PType.TYPECODE_STRING:
			return "?????";
		default:
			return super.getSqlType(pt, usedInPK);
		}
	}
}
